<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\MAN\Services;
use Teknisa\MAN\Services\FileUploaderService;
use Zeedhi\Framework\Util\Functions;

class GrupoPromocional extends  \Teknisa\MAN\Controllers\TeknisaCrud{

	protected $dataSourceName = 'vnd41000_grupoPromo';
	protected $parameterBagColumns = array('NRORG');
	protected $GrupoPromocionalService;
    protected $fileUploaderService;


	public function __construct ($crudService, $parameterBag, $entityManager, Services\GrupoPromocional $GrupoPromocionalService, FileUploaderService $fileUploaderService) {
		$this->crudService 				= $crudService;
		$this->parameterBag 			= $parameterBag;
		$this->entityManager 			= $entityManager;
		$this->GrupoPromocionalService 	= $GrupoPromocionalService;
        $this->fileUploaderService      = $fileUploaderService;
	}

    public function findGruProm(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'vnd41000_grupoPromo';
        parent::find($request, $response);
    }
    
    public function findModoExibeTaa(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'vnd41000_grupoPromo_findModoExibeTaa';
        parent::find($request, $response);
    }

    public function saveGruPromo(DTO\Request\DataSet $request, DTO\Response $response){
    	$row = $request->getDataSet()->getRows()[0];
    	if (!isset($row['DSENDEIMGGRUPROMOC']) || $row['IMAGE'] == '') {
    	    $row['DSENDEIMGGRUPROMOC'] = null;
    	}
        if(isset($row['IMAGE'][0]['path'])){
            if(Functions::arrayKeyExists('IMAGE', $row)) {
                $this->fileUploaderService->setImageForSave($row, 'DSENDEIMGGRUPROMOC', 'IMAGE');
            }
        }
    	if($row['__is_new']){
        	$row['CDGRUPROMOC'] = $this->GrupoPromocionalService->getCodigoGrupo();
    	}
    	parent::save($request, $response);
    }
}