<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;


class ParamTAAService {
    
	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
   public function saveMidias($params) {
        foreach ($params['CDCAIXA'] as $caixa) {
            $parameter = array(
                ':CDFILIAL'    => $params['CDFILIAL'],
                ':CDCAIXA'     => $caixa,
                ':TPMIDIATAA'  => $params['TPMIDIATAA'],
                ':LAYOUTMIDIA' => $params['LAYOUTMIDIA'], 
                ':NRORG'       => $params['NRORG'], 
                ':TMPDURACAO'  => $params['TMPDURACAO'],
                ':CDPRODUTO'   => $params['CDPRODUTO'],
                ':MIDIAURLTAA' => $params['MIDIAURLTAA']
            );
            
            $this->entityManager->getConnection()->executeQuery(self::INSERT_MIDIAS_TAA, $parameter);
        }
        
    }
    
    public function updateMidias($params) {
 	    $parameters = array(
            ':CDFILIAL'     => $params['CDFILIAL'],
            ':CDCAIXA'      => $params['CDCAIXA'],
            ':TPMIDIATAA'   => $params['TPMIDIATAA'],
            ':LAYOUTMIDIA'  => $params['LAYOUTMIDIA'],
            ':NRORG'        => $params['NRORG'],
            ':TMPDURACAO'   => $params['TMPDURACAO'],
            ':CDPRODUTO'    => $params['CDPRODUTO'],
            ':MIDIAURLTAA'  => $params['MIDIAURLTAA']
		);

		return $this->entityManager->getConnection()->executeQuery(self::UPDATE_MIDIAS_TAA, $parameters);
	}
           
    const INSERT_MIDIAS_TAA = "
		INSERT INTO MIDIATAA (CDFILIAL, CDCAIXA, TPMIDIATAA, LAYOUTMIDIA, NRORG, TMPDURACAO, CDPRODUTO, MIDIAURLTAA)
		VALUES (:CDFILIAL, :CDCAIXA, :TPMIDIATAA, :LAYOUTMIDIA, :NRORG, :TMPDURACAO, :CDPRODUTO, :MIDIAURLTAA)
	";
		
	const UPDATE_MIDIAS_TAA = "  
        UPDATE MIDIATAA 
           SET TPMIDIATAA     = :TPMIDIATAA,
               LAYOUTMIDIA    = :LAYOUTMIDIA,
               TMPDURACAO     = :TMPDURACAO,
               MIDIAURLTAA    = :MIDIAURLTAA
         WHERE CDFILIAL       = :CDFILIAL
		       AND NRORG      = :NRORG
		       AND CDCAIXA    = :CDCAIXA
		       AND CDPRODUTO  = :CDPRODUTO
    ";
}
	   



 