<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelVendaFiscalGerencialServices {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        
    }
  
	public function buscaFiscalGerencial($cdfilial,$dtinicial,$dtfinal) {
		$totalFiscal = 0;
		$totalGerencial = 0;
		$TOTAL = 0;
		$params = array(
	     	":P_CDFILIAL" => (($cdfilial) != 0) ? implode('_' ,$cdfilial) : null,
	     	":P_TCDFILIAL" => (count($cdfilial) != 0) ?  NULL : "T",
	      	":P_DTINI" => $dtinicial,
	     	":P_DTFIN" => $dtfinal
 		);
 		
 		$rowFiscalGerencial = $this->entityManager->getConnection()->fetchAll(self::FISCAL_GERENCIAL, $params);
 
 		for($i=0;$i<count($rowFiscalGerencial);$i++){
 			$paramsPerFiscalGerencial = array(
	     	":P_CDFILIAL" => (($cdfilial) != 0) ? implode('_' ,$cdfilial) : null,
	     	":P_CDLOJA" => $rowFiscalGerencial[$i]["CDLOJA"],
	     	":P_TCDFILIAL" => (count($cdfilial) != 0) ?  NULL : "T",
	      	":P_DTINI" => $dtinicial,
	     	":P_DTFIN" => $dtfinal,
	     	":P_TCDLOJA" => null,
 			); 		
 		
 			$paramsTotalFilial = array(
 				":P_CDFILIAL" => $rowFiscalGerencial[$i]["CDFILIAL"],
 				":P_DTINI" => $dtinicial,
 				":P_TCDFILIAL" => (count($cdfilial) != 0) ?  NULL : "T",
	     		":P_DTFIN" => $dtfinal
 				);
 			$rowTotalFilial = $this->entityManager->getConnection()->fetchAll(self::TOTAL_FISCAL_GERENCIAL, $paramsTotalFilial);
 			$rowPerFilial = $this->entityManager->getConnection()->fetchAll(self::PER_FISCAL_GERENCIAL, $paramsPerFiscalGerencial);
 			if(count($rowPerFilial)>1){
 				$totalFiscal = $rowPerFilial[0]["TOTALLOJA"];
 				$totalGerencial = $rowPerFilial[1]["TOTALLOJA"];
 				$TOTAL = $rowPerFilial[0]["TOTALLOJA"] + $rowPerFilial[1]["TOTALLOJA"];
 				$perLojaFiscal = ($totalFiscal*100)/$TOTAL;
 				$perLojaGerencial = ($totalGerencial*100)/$TOTAL;
 				$perLojaGerencial = number_format($perLojaGerencial, 2, '.', ',');
 			}else{
 				$totalFiscal = $rowPerFilial[0]["TOTALLOJA"];
 				$TOTAL = $rowPerFilial[0]["TOTALLOJA"];
 				$perLojaFiscal = 100;
 			}
 			
 			$rowFiscalGerencial[$i]["%Venda"] = ($rowFiscalGerencial[$i]["TOTAL"] * 100)/$rowTotalFilial[0]["TOTALFILIAL"];
 			$perLojaFiscal = number_format($perLojaFiscal, 2, '.', ',');
 			if(count($rowPerFilial)>1){
 				if($rowFiscalGerencial[$i]["IDVENDAGERENCIAL"] == "Venda Fiscal")
 					$rowFiscalGerencial[$i]["IDVENDAGERENCIAL"] = $rowFiscalGerencial[$i]["IDVENDAGERENCIAL"] . " - " . $perLojaFiscal . "%";
 				if($rowFiscalGerencial[$i]["IDVENDAGERENCIAL"] == "Venda Gerencial")
 				    $rowFiscalGerencial[$i]["IDVENDAGERENCIAL"] = $rowFiscalGerencial[$i]["IDVENDAGERENCIAL"] . " - " . $perLojaGerencial . "%";
 			}else{
 				$rowFiscalGerencial[$i]["IDVENDAGERENCIAL"] = $rowFiscalGerencial[$i]["IDVENDAGERENCIAL"] . " - " . $perLojaFiscal . "%";
 			}
 			
 			
 			
 		}
 
	 	return $rowFiscalGerencial ;
	}
	
	const FISCAL_GERENCIAL = "
  SELECT A.NMFILIAL, A.CDFILIAL, A.CDLOJA, A.IDVENDAGERENCIAL, A.NMTIPORECE, SUM(NVL(A.VALOR, 0) - NVL(B.VALOR, 0)) AS TOTAL FROM (SELECT  V.CDFILIAL|| ' - ' || F.NMFILIAL AS NMFILIAL,V.CDFILIAL, V.CDLOJA, (CASE V.IDVENDAGERENCIAL WHEN 'S' THEN 'Venda Gerencial' WHEN 'N' THEN 'Venda Fiscal' END) AS IDVENDAGERENCIAL,T.CDTIPORECE ||' - '|| T.NMTIPORECE AS NMTIPORECE,
         SUM(M.VRMOVIVEND) AS VALOR, T.CDTIPORECE, V.CDCAIXA, V.NRSEQVENDA
    FROM VENDA V, MOVCAIXA M, TIPORECE T,FILIAL F
   WHERE 
     V.CDFILIAL = M.CDFILIAL  AND
     V.CDCAIXA = M.CDCAIXA AND
     V.NRSEQVENDA = M.NRSEQVENDA AND  
     M.CDTIPORECE = T.CDTIPORECE AND
     V.IDVENDAGERENCIAL = 'S' AND
     V.IDSITUVENDA = 'O' AND
     V.CDFILIAL = F.CDFILIAL AND
     M.CDFILIAL = F.CDFILIAL AND
     M.IDTIPOMOVIVE = 'E' AND
     (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
     ((INSTR(:P_CDFILIAL, V.CDFILIAL          ) <> 0) OR (:P_TCDFILIAL = 'T'))
  GROUP BY V.CDFILIAL, V.CDLOJA, V.IDVENDAGERENCIAL,T.NMTIPORECE,T.CDTIPORECE,F.NMFILIAL, V.CDCAIXA, V.NRSEQVENDA
  ORDER BY CDFILIAL, CDLOJA,NMTIPORECE) A
  LEFT JOIN
  (SELECT  V.CDFILIAL|| ' - ' || F.NMFILIAL AS NMFILIAL,V.CDFILIAL, V.CDLOJA, (CASE V.IDVENDAGERENCIAL WHEN 'S' THEN 'Venda Gerencial' WHEN 'N' THEN 'Venda Fiscal' END) AS IDVENDAGERENCIAL,T.CDTIPORECE ||' - '|| T.NMTIPORECE AS NMTIPORECE,
         SUM(M.VRMOVIVEND) AS VALOR, T.CDTIPORECE, V.CDCAIXA, V.NRSEQVENDA
    FROM VENDA V, MOVCAIXA M, TIPORECE T,FILIAL F
   WHERE 
     V.CDFILIAL = M.CDFILIAL  AND
     V.CDCAIXA = M.CDCAIXA AND
     V.NRSEQVENDA = M.NRSEQVENDA AND  
     M.CDTIPORECE = T.CDTIPORECE AND
     V.IDVENDAGERENCIAL = 'S' AND
     V.IDSITUVENDA = 'O' AND
     V.CDFILIAL = F.CDFILIAL AND
     M.CDFILIAL = F.CDFILIAL AND
     M.IDTIPOMOVIVE = 'S' AND
     (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
     ((INSTR(:P_CDFILIAL, V.CDFILIAL          ) <> 0) OR (:P_TCDFILIAL = 'T'))
  GROUP BY V.CDFILIAL, V.CDLOJA, V.IDVENDAGERENCIAL,T.NMTIPORECE,T.CDTIPORECE,F.NMFILIAL, V.CDCAIXA, V.NRSEQVENDA
  ORDER BY CDFILIAL, CDLOJA,NMTIPORECE) B
  ON A.CDFILIAL = B.CDFILIAL
  AND A.CDCAIXA = B.CDCAIXA
  AND A.CDTIPORECE = B.CDTIPORECE
  AND A.NRSEQVENDA = B.NRSEQVENDA
  GROUP BY A.NMFILIAL, A.CDFILIAL, A.CDLOJA, A.IDVENDAGERENCIAL, A.NMTIPORECE
  UNION
  SELECT A.NMFILIAL, A.CDFILIAL, A.CDLOJA, A.IDVENDAGERENCIAL, A.NMTIPORECE, SUM(NVL(A.VALOR, 0) - NVL(B.VALOR, 0)) AS TOTAL FROM (SELECT  V.CDFILIAL|| ' - ' || F.NMFILIAL AS NMFILIAL,V.CDFILIAL, V.CDLOJA, (CASE V.IDVENDAGERENCIAL WHEN 'S' THEN 'Venda Gerencial' WHEN 'N' THEN 'Venda Fiscal' END) AS IDVENDAGERENCIAL,T.CDTIPORECE ||' - '|| T.NMTIPORECE AS NMTIPORECE,
         SUM(M.VRMOVIVEND) AS VALOR, T.CDTIPORECE, V.CDCAIXA, V.NRSEQVENDA
    FROM VENDA V, MOVCAIXA M, TIPORECE T,FILIAL F
   WHERE 
     V.CDFILIAL = M.CDFILIAL  AND
     V.CDCAIXA = M.CDCAIXA AND
     V.NRSEQVENDA = M.NRSEQVENDA AND  
     M.CDTIPORECE = T.CDTIPORECE AND
     V.IDVENDAGERENCIAL = 'N' AND
     V.IDSITUVENDA = 'O' AND
     V.CDFILIAL = F.CDFILIAL AND
     M.CDFILIAL = F.CDFILIAL AND
     M.IDTIPOMOVIVE = 'E' AND
     (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
     ((INSTR(:P_CDFILIAL, V.CDFILIAL          ) <> 0) OR (:P_TCDFILIAL = 'T'))
  GROUP BY V.CDFILIAL, V.CDLOJA, V.IDVENDAGERENCIAL,T.NMTIPORECE,T.CDTIPORECE,F.NMFILIAL, V.CDCAIXA, V.NRSEQVENDA
  ORDER BY CDFILIAL, CDLOJA,NMTIPORECE) A
  LEFT JOIN
  (SELECT  V.CDFILIAL|| ' - ' || F.NMFILIAL AS NMFILIAL,V.CDFILIAL, V.CDLOJA, (CASE V.IDVENDAGERENCIAL WHEN 'S' THEN 'Venda Gerencial' WHEN 'N' THEN 'Venda Fiscal' END) AS IDVENDAGERENCIAL,T.CDTIPORECE ||' - '|| T.NMTIPORECE AS NMTIPORECE,
         SUM(M.VRMOVIVEND) AS VALOR, T.CDTIPORECE, V.CDCAIXA, V.NRSEQVENDA
    FROM VENDA V, MOVCAIXA M, TIPORECE T,FILIAL F
   WHERE 
     V.CDFILIAL = M.CDFILIAL  AND
     V.CDCAIXA = M.CDCAIXA AND
     V.NRSEQVENDA = M.NRSEQVENDA AND  
     M.CDTIPORECE = T.CDTIPORECE AND
     V.IDVENDAGERENCIAL = 'N' AND
     V.IDSITUVENDA = 'O' AND
     V.CDFILIAL = F.CDFILIAL AND
     M.CDFILIAL = F.CDFILIAL AND
     M.IDTIPOMOVIVE = 'S' AND
     (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
     ((INSTR(:P_CDFILIAL, V.CDFILIAL          ) <> 0) OR (:P_TCDFILIAL = 'T'))
  GROUP BY V.CDFILIAL, V.CDLOJA, V.IDVENDAGERENCIAL,T.NMTIPORECE,T.CDTIPORECE,F.NMFILIAL, V.CDCAIXA, V.NRSEQVENDA
  ORDER BY CDFILIAL, CDLOJA,NMTIPORECE) B
  ON A.CDFILIAL = B.CDFILIAL
  AND A.CDCAIXA = B.CDCAIXA
  AND A.CDTIPORECE = B.CDTIPORECE
  AND A.NRSEQVENDA = B.NRSEQVENDA
  GROUP BY A.NMFILIAL, A.CDFILIAL, A.CDLOJA, A.IDVENDAGERENCIAL, A.NMTIPORECE
  ";
  
  const TOTAL_FISCAL_GERENCIAL = "
  SELECT SUM(NVL(A.TOTALFILIAL, 0) - NVL(B.TOTALFILIAL, 0)) AS TOTALFILIAL 
  FROM (SELECT SUM(M.VRMOVIVEND) AS TOTALFILIAL, V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE
    FROM VENDA V, MOVCAIXA M, TIPORECE T
   WHERE 
     V.CDFILIAL = M.CDFILIAL  AND
     V.CDCAIXA = M.CDCAIXA AND
     V.NRSEQVENDA = M.NRSEQVENDA AND
     M.CDTIPORECE = T.CDTIPORECE AND
     V.IDSITUVENDA = 'O' AND
     M.IDTIPOMOVIVE = 'E' AND
     (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
     ((INSTR(:P_CDFILIAL, V.CDFILIAL ) <> 0) OR (:P_TCDFILIAL = 'T'))
    GROUP BY V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE) A 
   LEFT JOIN (SELECT SUM(M.VRMOVIVEND) AS TOTALFILIAL, V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE
    FROM VENDA V, MOVCAIXA M, TIPORECE T
   WHERE 
     V.CDFILIAL = M.CDFILIAL  AND
     V.CDCAIXA = M.CDCAIXA AND
     V.NRSEQVENDA = M.NRSEQVENDA AND
     M.CDTIPORECE = T.CDTIPORECE AND
     V.IDSITUVENDA = 'O' AND
     M.IDTIPOMOVIVE = 'S' AND
     (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
     ((INSTR(:P_CDFILIAL, V.CDFILIAL ) <> 0) OR (:P_TCDFILIAL = 'T'))
    GROUP BY V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE) B
    ON A.CDFILIAL = B.CDFILIAL
    AND A.CDCAIXA = B.CDCAIXA
    AND A.CDTIPORECE = B.CDTIPORECE
    AND A.NRSEQVENDA = B.NRSEQVENDA
  ";
  
  const PER_FISCAL_GERENCIAL = "
  SELECT SUM(NVL(A.TOTALLOJA, 0) - NVL(B.TOTALLOJA, 0)) AS TOTALLOJA, A.IDVENDAGERENCIAL  FROM (SELECT SUM(M.VRMOVIVEND) AS TOTALLOJA,(CASE V.IDVENDAGERENCIAL WHEN 'S' THEN 'Venda Gerencial' WHEN 'N' THEN 'Venda Fiscal' END) AS IDVENDAGERENCIAL, V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE
  FROM VENDA V, MOVCAIXA M, TIPORECE T
  WHERE 
  V.CDFILIAL = M.CDFILIAL AND
  V.CDCAIXA = M.CDCAIXA AND
  V.NRSEQVENDA = M.NRSEQVENDA AND
  M.CDTIPORECE = T.CDTIPORECE AND
  V.IDSITUVENDA = 'O' AND
  M.IDTIPOMOVIVE = 'E' AND
  (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
  ((INSTR(:P_CDFILIAL, V.CDFILIAL ) <> 0) OR (:P_TCDFILIAL = 'T')) AND
  ((INSTR(:P_CDLOJA, V.CDLOJA) <> 0) OR (:P_TCDLOJA = 'T'))
  GROUP BY V.IDVENDAGERENCIAL, V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE) A
  LEFT JOIN (SELECT SUM(M.VRMOVIVEND) AS TOTALLOJA,(CASE V.IDVENDAGERENCIAL WHEN 'S' THEN 'Venda Gerencial' WHEN 'N' THEN 'Venda Fiscal' END), V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE
              FROM VENDA V, MOVCAIXA M, TIPORECE T
              WHERE V.CDFILIAL = M.CDFILIAL AND
                V.CDCAIXA = M.CDCAIXA AND
                V.NRSEQVENDA = M.NRSEQVENDA AND
                M.CDTIPORECE = T.CDTIPORECE AND
                V.IDSITUVENDA = 'O' AND
                M.IDTIPOMOVIVE = 'S' AND
                (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
                ((INSTR(:P_CDFILIAL, V.CDFILIAL ) <> 0) OR (:P_TCDFILIAL = 'T')) AND
                ((INSTR(:P_CDLOJA, V.CDLOJA) <> 0) OR (:P_TCDLOJA = 'T'))
                GROUP BY V.IDVENDAGERENCIAL, V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE) B
   ON A.CDFILIAL = B.CDFILIAL
   AND A.CDCAIXA = B.CDCAIXA
   AND A.NRSEQVENDA = B.NRSEQVENDA
   AND A.CDTIPORECE = B.CDTIPORECE
   GROUP BY A.IDVENDAGERENCIAL
  ";
}
